from os.path import exists
from datetime import datetime



class FlushOut():
    """A flushing file-like class for output to the log"""

    def __init__(self, fname):
        self.fname = fname
        self.f = None
        self.__open()

    def write(self, d):
        self.__force_existance()
        self.f.write(d)
        self.f.flush()

    def __open(self):
        self.f = open(self.fname, "a+")

    def __force_existance(self):
        if not exists(self.fname):
            self.__open()
            self.write("--CONTINUED at %s--\n" %
                datetime.utcnow())

    def __getattr__(self, name):
        self.__force_existance()
        attr = getattr(self.f, name)
        return attr
