from GwErrors import GwRouteError

RS485 = 1
RADIO_868 = 2
RADIO_173 = 3
USB = 4
RADIOMETRIX = 5

RADIO_LINKS = {RS485: "RS485", RADIO_868: "RADIO_868",
             RADIO_173: "RADIO_173", USB: "USB", RADIOMETRIX: "RADIOMETRIX"}


class Gw12Route:
    dest_id = None
    source_id = None
    link = None

    def __init__(self, dest_id, source_id, link):
        self.dest_id = dest_id
        self.source_id = source_id
        if link in RADIO_LINKS.keys():
            self.link = link
        else:
            raise GwRouteError()

    def __str__(self):
        return "Dest: %d Source: %d  link %s" % \
            (self.dest_id, self.source_id, RADIO_LINKS[self.link])


def parse(resp):
    table = []
    for line in resp:
        arr = line.split("\t")
        table.append(Gw12Route(int(arr[0]), int(arr[1]), int(arr[2])))
    return table
