# convert ascii raw probe data to units if possible, etc

from sys import argv
from datetime import datetime


class readings:
    """ a class to hold a line/set of readings"""
    epoch = None  # 0
    rtcval = None  # 1
    bat_volts = None  # 2
    vdd = None  # 3
    temperature_platinum = None  # 4
    temperature_internal = None  # 5
    temperature_internal_celcius = None   # 6
    pressure = None  # 7
    strain = None  # 8
    conductivity = None  # 9
    accel_x = None  # 10
    accel_y = None  # 11
    accel_z = None  # 12
    compass_x = None  # 13
    compass_y = None  # 14
    compass_z = None  # 15
    gyro_x = None  # 16
    gyro_y = None  # 17
    gyro_z = None  # 18

    def __init__(self):
        pass

    def __str__(self):
        return (str(self.epoch) + " %s %f %f %f %f" % (self.bat_volts,
            self.vdd, self.accel_x, self.accel_y, self.accel_z))


def conv_platinum(adc):
    return adc


def _conv_pressure(raw):
    pass


def _conv_strain(raw):
    pass

def _conv_cond(raw):
    pass


def _conv_accel(raw):
    return float(raw) / 4096


def _conv_compass(raw):
    pass


def _conv_gyro(raw):
    pass


def parseline(s):
    r = readings()
    arr = s.split("\t")
    r.epoch = datetime.utcfromtimestamp(float(arr[0]))
    r.bat_volts = float(arr[2])
    r.vdd = float(arr[3])
    r.temperature_platinum = conv_platinum(arr[4])

    r.accel_x = _conv_accel(arr[10])
    r.accel_y = _conv_accel(arr[11])
    r.accel_z = _conv_accel(arr[12])
    return r


def convertfile(filename):
    try:
        f = open(filename, "r")
    except IOError:
        print "can not open file"
        exit(1)

    for line in f:
        r = parseline(line)
        print str(r)

    f.close()

if __name__ == "__main__":
    convertfile(argv[1])
