import logging
from logging.handlers import WatchedFileHandler
from logging import DEBUG, INFO, WARN, ERROR, CRITICAL

from FlushOut import FlushOut
from variables import BASE_DIR, DATA_DIR
MSP = 5

# Set the level of logging output here.  Available options:
# MSP
# DEBUG
# INFO
# WARN
# ERROR
# CRITICAL

LOG_LEVEL = MSP

logging.addLevelName(5, 'MSP')
logger = logging.getLogger("gwstation")

logger.setLevel(LOG_LEVEL)


setattr(logger, 'msp', lambda *args: logger.log(MSP, *args))
#Format to use for logging
f = logging.Formatter('%(asctime)s - %(filename)s:%(lineno)s - ' +
    '%(levelname)s - %(message)s', '%d/%m/%Y %H:%M:%S')

#setup console output
c = logging.StreamHandler()
c.setFormatter(f)
logger.addHandler(c)
lf = WatchedFileHandler("output")
lf.setFormatter(f)
logger.addHandler(lf)


def daemonize(filename):
    lf = WatchedFileHandler(filename)
    lf.setFormatter(f)
    logger.addHandler(lf)


# Output stuff from external executables to file
gw_stdout = FlushOut(BASE_DIR + DATA_DIR +
                        "/executable_output")
gw_stderr = gw_stdout
