#!/usr/bin/env python
from Gw12 import Gw12, REMOTE_PROBES, PROBE_BROADCAST
from gwlogging import logger
from GwErrors import GwError

from datetime import datetime

THRESHOLD = 4

if __name__ == "__main__":
    g = Gw12()
    try:
        g.rtcset(PROBE_BROADCAST, datetime.utcnow())
    except GwError:
        logger.warn("caught error ignoring due to dodgy broadcast response")
    for p in REMOTE_PROBES:
        logger.info("Checking node: %d" % p)
        diff = datetime.utcnow() - g.rtcget(p)
        while pow(diff, 2) > THRESHOLD:
            g.rtcset(p, datetime.utcnow())
            diff = datetime.utcnow() - g.rtcget(p)
