#!/usr/bin/env python

from gwlogging import logger
from Gw12 import Gw12, WIRED_PROBE, REMOTE_PROBES
from GwErrors import GwProbeExecutionError
from variables import MAX_PROBE_PING_REPEATS

from random import shuffle

if __name__ == "__main__":
    logger.debug("Trying wired probes")
    probe_interface = Gw12()
    try:
        print probe_interface.nodestatus(WIRED_PROBE)
    except GwProbeExecutionError:
        logger.critical("Unable to ping wired probe attempt 1")
    try:
        print probe_interface.nodestatus(WIRED_PROBE)
    except GwProbeExecutionError:
        logger.critical("Unable to ping wired probe = giving up")
        exit(1)

    shuffle(REMOTE_PROBES)
    logger.debug("Remote probes shuffled")
    logger.debug(REMOTE_PROBES)
    i = 0
    try:
        while i < MAX_PROBE_PING_REPEATS:
            for probe in REMOTE_PROBES:
                try:
                    probe_interface.nodestatus(probe)
                    logger.info("Got status from %s" % probe)
                    probe_interface.get_files(probe)
                    logger.info("Finished doing transfers" % probe)
                    probe_interface.nodesleep(probe)
                    logger.info("Probe %s sent to sleep" % probe)
                    REMOTE_PROBES.remove(probe)
                except GwProbeExecutionError:
                    logger.error("Failed to get comms from %s" % probe)
            if REMOTE_PROBES == []:
                logger.info("All probes spoken to")
                break
            i += 1
    except KeyboardInterrupt:
        logger.warn("Halted by keyboard")
    logger.info("Getting data from wired probe")
    probe_interface.get_files(WIRED_PROBE)
    logger.info("Dumped data from wired probe")
